/*--------------------------------------------------------------------------+
$Id: codetemplates.xml 1 2011-01-01 00:00:01Z hoelzl $
|                                                                          |
| Copyright 2012 ForTISS GmbH                     |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.tooling.kernel.extension.base;

import org.fortiss.tooling.kernel.model.ILibraryElement;

/**
 * The base class for prototype providers for library elements.
 * 
 * @author ratiu
 * @author $Author: hoelzl $
 * @version $Rev: 18709 $
 * @ConQAT.Rating RED Hash:
 */
public abstract class LibraryPrototypeProviderBase extends PrototypeProviderBase {

	/**
	 * Refreshes the list of prototypes to synchronize them with the current state
	 * of the library.
	 */
	public void refreshPrototypes() {
		prototypes.clear();
		registerPrototypes();
	}

	/** Returns the kind of the library element for which this class provides prototypes. */
	public abstract <T extends ILibraryElement> Class<T> getPrototypeKind();
}
