/*--------------------------------------------------------------------------+
$Id$
|                                                                          |
| Copyright 2012 ForTISS GmbH                     |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.tooling.kernel.extension.data;

import java.util.ArrayList;

/**
 * Container object for prototypes of a certain category.
 * 
 * @author doebber
 * @author $Author$
 * @version $Rev$
 * @ConQAT.Rating GREEN Hash: E51B16B14246DBE6D73D62B1424E852F
 */
public class ProtoypeCategory {

	/** Constructor. */
	public ProtoypeCategory(String category) {
		categoryName = category;
	}

	/** Stores the name of the category. */
	private final String categoryName;

	/** Stores the prototypes affiliated with this category. */
	private ArrayList<Prototype> children = new ArrayList<Prototype>();

	/** Adds the prototype. */
	public void add(Prototype prototype) {
		children.add(prototype);
	}

	/** Returns the members of this category. */
	public Object[] getChildren() {
		return children.toArray();
	}

	/** Returns the name of the category. */
	public String getName() {
		return categoryName;
	}
}
